package test;

import junit.framework.TestCase;
import compiler.*;

/**
 * <p>Title: Programming mini project 2 Java-- compiler</p>
 * <p>Description: tests the resolveSuperClass method in ClassSymbol</p>
 * <p>Copyright: Copyright (c) 2004 Nicholas Cameron</p>
 * <p>Company: </p>
 * @author Nicholas Cameron
 * @version 1.0
 */

public class TestResolveSuperClass extends TestCase
{
    java.io.PrintWriter out = new java.io.PrintWriter(System.out, true);
    public TestResolveSuperClass()
    {
    }

    public void testSimpleResolve()
    {
        SymbolTable st = new SymbolTable(null);
        ClassSymbol object = new ClassSymbol("Object", null, null);
        ClassSymbol cs1 = new ClassSymbol("test1", "Object", null, new SymbolTable());
        st.put(object);
        st.put(cs1);

        assertTrue("cs1 should resolve", cs1.resolveSuperClass(st, out));
    }

    public void testSimpleNotResolve()
    {
        SymbolTable st = new SymbolTable(null);
        ClassSymbol cs1 = new ClassSymbol("test1", "test2", new ast.ClassNode("test1", "test2", null, 0, 0), new SymbolTable());
        st.put(cs1);

        assertFalse("cs1 not should resolve", cs1.resolveSuperClass(st, out));
    }

    public void testCyclic1()
    {
        SymbolTable st = new SymbolTable(null);
        ClassSymbol cs1 = new ClassSymbol("test1", "test1", new ast.ClassNode("test1", "test1", null, 0, 0), new SymbolTable());
        st.put(cs1);

        assertFalse("cs1 not should resolve", cs1.resolveSuperClass(st, out));
    }

    public void testCyclic2()
    {
        SymbolTable st = new SymbolTable(null);
        ClassSymbol cs1 = new ClassSymbol("test1", "test2", new ast.ClassNode("test1", "test2", null, 0, 0), new SymbolTable());
        ClassSymbol cs2 = new ClassSymbol("test2", "test1", new ast.ClassNode("test2", "test1", null, 0, 0), new SymbolTable());
        st.put(cs1);
        st.put(cs2);

        assertFalse("cs1 not should resolve", cs1.resolveSuperClass(st, out));
        assertFalse("cs2 not should resolve", cs2.resolveSuperClass(st, out));
    }

    public void testUndefined2()
    {
        SymbolTable st = new SymbolTable(null);
        ClassSymbol cs1 = new ClassSymbol("test1", "test2", new ast.ClassNode("test1", "test2", null, 0, 0), new SymbolTable());
        ClassSymbol cs2 = new ClassSymbol("test2", "test3", new ast.ClassNode("test2", "test3", null, 0, 0), new SymbolTable());
        st.put(cs1);
        st.put(cs2);

        assertFalse("cs1 not should resolve", cs1.resolveSuperClass(st, out));
        assertFalse("cs2 not should resolve", cs2.resolveSuperClass(st, out));
    }

    public void testResolve2()
    {
        SymbolTable st = new SymbolTable(null);
        ClassSymbol object = new ClassSymbol("Object", null, null);
        ClassSymbol cs1 = new ClassSymbol("test1", "test2", new ast.ClassNode("test1", "test2", null, 0, 0), new SymbolTable());
        ClassSymbol cs2 = new ClassSymbol("test2", "Object", new ast.ClassNode("test2", null, null, 0, 0), new SymbolTable());
        st.put(object);
        st.put(cs1);
        st.put(cs2);

        assertTrue("cs1 should resolve", cs1.resolveSuperClass(st, out));
        assertTrue("cs2 should resolve", cs2.resolveSuperClass(st, out));
    }

    public void testNotClass()
    {
        SymbolTable st = new SymbolTable(null);
        VariableSymbol vs1 = new VariableSymbol("Object", "Object", new ast.VarNode("Object", 0, 0));
        ClassSymbol cs1 = new ClassSymbol("test1", "Object", new ast.ClassNode("test1", "Object", null, 0, 0), new SymbolTable());
        st.put(vs1);
        st.put(cs1);

        assertFalse("cs1 should resolve", cs1.resolveSuperClass(st, out));
    }
}